<?php // a PHP port of Porter's stemming algorithm

function stem($word) {

 	//$w = strtolower(ereg_replace("'s$","",$word));
 	$w = eregi_replace("'s$","",$word);
	$w = eregi_replace("[^a-z]","",$w);
	if(strlen($w)==0) return $word; // not a word to stem

	// step1a_rules
	if(eregi("[^s]s$",$w)) {
		if(eregi("sses$",$w)) {
			$w = eregi_replace("sses$","ss",$w);
		} elseif(eregi("ies$",$w)) {
			$w = eregi_replace("ies$","i",$w);
		} elseif(eregi("s$",$w)) {
			$w = eregi_replace("s$","",$w);
		}
	}


	if( 
	eregi("([aeiouy][^aeiouy][a-z]+)eed$",$w) 
	or eregi("([aeiouy][a-z]+)ed$",$w) 
	or eregi("([aeiouy][a-z]+)ing$",$w) ) {

		//print "step1a match\n";

		$w = eregi_replace("([aeiouy][^aeiouy][a-z]+)eed$","\\1ee",$w);
		$w = eregi_replace("([aeiouy][a-z]+)ed$","\\1",$w);
		$w = eregi_replace("([aeiouy][a-z]+)ing$","\\1",$w); 
		$fix_suffix = TRUE;

	}

	// step1b
	if($fix_suffix) {

		$w = eregi_replace("at$","ate",$w);
		$w = eregi_replace("bl$","ble",$w);
		$w = eregi_replace("iz$","ize",$w); 
		$w = eregi_replace("bb$","b",$w);
		$w = eregi_replace("dd$","d",$w);   
		$w = eregi_replace("ff$","f",$w);
		$w = eregi_replace("gg$","g",$w);    
		$w = eregi_replace("mm$","m",$w);
		$w = eregi_replace("nn$","n",$w);    
		$w = eregi_replace("pp$","p",$w);
		$w = eregi_replace("rr$","r",$w);    
		$w = eregi_replace("tt$","t",$w);
		$w = eregi_replace("ww$","w",$w);    
		$w = eregi_replace("xx$","x",$w);
		// ?? $w = eregi_replace("^([^aeiouy]+[aeiouy][^aeiouy])$","\\1e",$w);
		$w = eregi_replace("([a-z][^aeiouy]+)$","\\1e",$w);
	}



	# step2_rules

	$w = eregi_replace("ational$","ate",$w);	
	$w = eregi_replace("tional$","tion",$w);	
	$w = eregi_replace("enci$","ence",$w);
	$w = eregi_replace("anci$","ance",$w);
	$w = eregi_replace("izer$","ize",$w);	
	$w = eregi_replace("iser$","ise",$w);	
	$w = eregi_replace("abli$","able",$w);
	$w = eregi_replace("alli$","al",$w);	
	$w = eregi_replace("entli$","ent",$w);
	$w = eregi_replace("eli$","e",$w);
	$w = eregi_replace("ousli$","ous",$w);
	$w = eregi_replace("ization$","ize",$w);	
	$w = eregi_replace("isation$","ise",$w);		
	$w = eregi_replace("ation$","ate",$w);
	$w = eregi_replace("ator$","ate",$w);	
	$w = eregi_replace("alism$","al",$w);
	//$w = eregi_replace("iveness$","ive",$w);	
	//$w = eregi_replace("fulnes$","ful",$w);	
	//$w = eregi_replace("ousness$","ous",$w);	
	$w = eregi_replace("aliti$","al",$w);		
	$w = eregi_replace("iviti$","ive",$w);
	$w = eregi_replace("biliti$","ble",$w);


	# step3_rules

	$w = eregi_replace("icate$","ic",$w);
	$w = eregi_replace("ative$","",$w);
	$w = eregi_replace("alize$","al",$w);
	$w = eregi_replace("iciti$","ic",$w);
	$w = eregi_replace("ical$","ic",$w);
	$w = eregi_replace("ful$","",$w);
	$w = eregi_replace("ness$","",$w);

	# step4_rules
	// need if test here, to see if words are like cement or stable...

	$w = eregi_replace("al$","",$w);		
	$w = eregi_replace("ance$","",$w);
	$w = eregi_replace("ence$","",$w);
	$w = eregi_replace("er$","",$w);
	$w = eregi_replace("ic$","",$w);	
	$w = eregi_replace("able$","",$w);
	$w = eregi_replace("ible$","",$w);
	$w = eregi_replace("ant$","",$w);
	$w = eregi_replace("ement$","",$w);
	$w = eregi_replace("ment$","",$w);
	$w = eregi_replace("ent$","",$w);
	$w = eregi_replace("sion$","s",$w);
	$w = eregi_replace("([^p])tion$","\\1t",$w);	
	$w = eregi_replace("ou$","",$w);	
	$w = eregi_replace("ism$","",$w);
	$w = eregi_replace("ate$","",$w);
	$w = eregi_replace("iti$","",$w);
	$w = eregi_replace("ous$","",$w);
	$w = eregi_replace("ive$","",$w);
	$w = eregi_replace("ize$","",$w);
	$w = eregi_replace("ise$","",$w);

/*


	# step5a_rules
#DEBUG	warn("step 5a: $_\n") &&
	s/e$// if ( /[^aeiou][aeiouy].*[^aeiou][aeiouy].*e$/ ||
		( /[aeiou][^aeiouy].*e/ && ! /[^aeiou][aeiouy][^aeiouwxy]e$/) );

	# step5b_rules
#DEBUG	warn("step 5b: $_\n") &&
	s/ll$/l/ if /[^aeiou][aeiouy].*[^aeiou][aeiouy].*ll$/;

*/

	// Cosmetic step 
	$w = eregi_replace("(.)i$","\\1y",$w);

return $w;
}

// end of stemming function

$fp = fopen("./test.txt","r");

$read = fread($fp,filesize("./test.txt"));

fclose($fp);

$array = explode(" ",$read);

for($i=0; $i<count($array); $i++) {
 print stem("$array[$i]") . "\n";
}

?>
